TrieDateField (Solr 3.6.2 API)
Keywords: org.apache.solr.schema.TrieDateField class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.schema
Class TrieDateField

    java.lang.Object
      org.apache.solr.schema.FieldProperties
          org.apache.solr.schema.FieldType
              org.apache.solr.schema.PrimitiveFieldType
                  org.apache.solr.schema.DateField
                      org.apache.solr.schema.TrieDateField

    public class TrieDateField

extends DateField

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType
`FieldType.DefaultAnalyzer`

Field Summary

Fields inherited from class org.apache.solr.schema.DateField
`CANONICAL_LOCALE, CANONICAL_TZ, MATH_LOCALE, MATH_TZ, NOW, UTC, Z`

Fields inherited from class org.apache.solr.schema.FieldType
`analyzer, args, falseProperties, log, POLY_FIELD_SEPARATOR, queryAnalyzer, trueProperties, typeName`

Fields inherited from class org.apache.solr.schema.FieldProperties
`BINARY, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_TERMOFFSETS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED`

Constructor Summary
`TrieDateField()`

Method Summary
`Fieldable` | `createField(SchemaField field, String externalVal, float boost)` Used for adding a document when a field needs to be created from a type and a string.
`int` | `getPrecisionStep()`
`Query` | `getRangeQuery(QParser parser, SchemaField sf, Date min, Date max, boolean minInclusive, boolean maxInclusive)` DateField specific range query
`Query` | `getRangeQuery(QParser parser, SchemaField field, String min, String max, boolean minInclusive, boolean maxInclusive)` Returns a Query instance for doing range searches on this field type.
`SortField` | `getSortField(SchemaField field, boolean top)` Returns the SortField instance that should be used to sort fields of this type.
`ValueSource` | `getValueSource(SchemaField field, QParser parser)` called to get the default value source (normally, from the Lucene FieldCache.)
`String` | `indexedToReadable(String indexedForm)` Given an indexed term, return the human readable representation
`protected void` | `init(IndexSchema schema, Map<String,String> args)` subclasses should initialize themselves with the args provided and remove valid arguments.
`boolean` | `isTokenized()` Returns true if fields of this type should be tokenized
`boolean` | `multiValuedFieldCache()` Returns true if a single field value of this type has multiple logical values for the purposes of faceting, sorting, etc.
`String` | `readableToIndexed(String val)` Given the readable value, return the term value that will match it.
`String` | `storedToIndexed(Fieldable f)` Given the stored field, return the indexed form
`String` | `storedToReadable(Fieldable f)` Given the stored field, return the human readable representation
`String` | `toExternal(Fieldable f)` Convert the stored-field format to an external (string, human readable) value
`String` | `toInternal(String val)` Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).
`Date` | `toObject(Fieldable f)` Convert the stored-field format to an external object.
`void` | `write(TextResponseWriter writer, String name, Fieldable f)` calls back to TextResponseWriter to write the field value
`void` | `write(XMLWriter xmlWriter, String name, Fieldable f)` Renders the specified field as XML

Methods inherited from class org.apache.solr.schema.DateField
`formatDate, formatExternal, getThreadLocalDateFormat, parseDate, parseDateLenient, parseMath, parseMathLenient, toExternal, toInternal, toObject`

Methods inherited from class org.apache.solr.schema.FieldType
`createField, createFields, getAnalyzer, getArg, getFieldIndex, getFieldQuery, getFieldStore, getFieldTermVec, getIndexOptions, getQueryAnalyzer, getStringSort, getTypeName, getValueSource, hasProperty, isMultiValued, isPolyField, restrictProps, setAnalyzer, setQueryAnalyzer, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### TrieDateField

    public TrieDateField()

Method Detail

### init

    protected void init(IndexSchema schema,
                        Map<String,String> args)

  Description copied from class: `FieldType`
  subclasses should initialize themselves with the args provided and remove valid arguments. leftover arguments will cause an exception. Common boolean properties have already been handled.

  Overrides:
    `init` in class `PrimitiveFieldType`

### toObject

    public Date toObject(Fieldable f)

  Description copied from class: `FieldType`
  Convert the stored-field format to an external object.

  Overrides:
    `toObject` in class `DateField`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### getSortField

    public SortField getSortField(SchemaField field,
                                  boolean top)

  Description copied from class: `FieldType`
  Returns the SortField instance that should be used to sort fields of this type.

  Overrides:
    `getSortField` in class `DateField`
  See Also:
    `SchemaField.checkSortability()`

### getValueSource

    public ValueSource getValueSource(SchemaField field,
                                      QParser parser)

  Description copied from class: `FieldType`
  called to get the default value source (normally, from the Lucene FieldCache.)

  Overrides:
    `getValueSource` in class `DateField`

### getPrecisionStep

    public int getPrecisionStep()

  Returns:
    the precisionStep used to index values into the field

### write

    public void write(XMLWriter xmlWriter,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  Renders the specified field as XML

  Overrides:
    `write` in class `DateField`
  Throws:
    `IOException`

### write

    public void write(TextResponseWriter writer,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  calls back to TextResponseWriter to write the field value

  Overrides:
    `write` in class `DateField`
  Throws:
    `IOException`

### isTokenized

    public boolean isTokenized()

  Description copied from class: `FieldType`
  Returns true if fields of this type should be tokenized

  Overrides:
    `isTokenized` in class `FieldType`

### multiValuedFieldCache

    public boolean multiValuedFieldCache()

  Description copied from class: `FieldType`
  Returns true if a single field value of this type has multiple logical values for the purposes of faceting, sorting, etc. Text fields normally return true since each token/word is a logical value.

  Overrides:
    `multiValuedFieldCache` in class `FieldType`

### storedToReadable

    public String storedToReadable(Fieldable f)

  Description copied from class: `FieldType`
  Given the stored field, return the human readable representation

  Overrides:
    `storedToReadable` in class `FieldType`

### readableToIndexed

    public String readableToIndexed(String val)

  Description copied from class: `FieldType`
  Given the readable value, return the term value that will match it.

  Overrides:
    `readableToIndexed` in class `FieldType`

### toInternal

    public String toInternal(String val)

  Description copied from class: `FieldType`
  Convert an external value (from XML update command or from query string) into the internal format for both storing and indexing (which can be modified by any analyzers).

  Overrides:
    `toInternal` in class `DateField`
  See Also:
    `FieldType.toExternal(org.apache.lucene.document.Fieldable)`

### toExternal

    public String toExternal(Fieldable f)

  Description copied from class: `FieldType`
  Convert the stored-field format to an external (string, human readable) value

  Overrides:
    `toExternal` in class `DateField`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### indexedToReadable

    public String indexedToReadable(String indexedForm)

  Description copied from class: `FieldType`
  Given an indexed term, return the human readable representation

  Overrides:
    `indexedToReadable` in class `DateField`

### storedToIndexed

    public String storedToIndexed(Fieldable f)

  Description copied from class: `FieldType`
  Given the stored field, return the indexed form

  Overrides:
    `storedToIndexed` in class `FieldType`

### createField

    public Fieldable createField(SchemaField field,
                                 String externalVal,
                                 float boost)

  Description copied from class: `FieldType`
  Used for adding a document when a field needs to be created from a type and a string.

  By default, the indexed value is the same as the stored value (taken from toInternal()). Having a different representation for external, internal, and indexed would present quite a few problems given the current Lucene architecture. An analyzer for adding docs would need to translate internal->indexed while an analyzer for querying would need to translate external->indexed.

  The only other alternative to having internal==indexed would be to have internal==external. In this case, toInternal should convert to the indexed representation, toExternal() should do nothing, and createField() should *not* call toInternal, but use the external value and set tokenized=true to get Lucene to convert to the internal(indexed) form.

  :TODO: clean up and clarify this explanation.

  Overrides:
    `createField` in class `FieldType`
  See Also:
    `FieldType.toInternal(java.lang.String)`

### getRangeQuery

    public Query getRangeQuery(QParser parser,
                               SchemaField field,
                               String min,
                               String max,
                               boolean minInclusive,
                               boolean maxInclusive)

  Description copied from class: `FieldType`
  Returns a Query instance for doing range searches on this field type. `SolrQueryParser` currently passes part1 and part2 as null if they are '*' respectively. minInclusive and maxInclusive are both true currently by SolrQueryParser but that may change in the future. Also, other QueryParser implementations may have different semantics.

  Sub-classes should override this method to provide their own range query implementation. They should strive to handle nulls in part1 and/or part2 as well as unequal minInclusive and maxInclusive parameters gracefully.

  Overrides:
    `getRangeQuery` in class `FieldType`
    `field` - the schema field
    `min` - the lower boundary of the range, nulls are allowed.
    `max` - the upper boundary of the range, nulls are allowed
    `minInclusive` - whether the minimum of the range is inclusive or not
    `maxInclusive` - whether the maximum of the range is inclusive or not
  Returns:
    a Query instance to perform range search according to given parameters
  See Also:
    `SolrQueryParser.getRangeQuery(String, String, String, boolean)`

### getRangeQuery

    public Query getRangeQuery(QParser parser,
                               SchemaField sf,
                               Date min,
                               Date max,
                               boolean minInclusive,
                               boolean maxInclusive)

  Description copied from class: `DateField`
  DateField specific range query

  Overrides:
    `getRangeQuery` in class `DateField`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD